---
export const prerender = true;
import type { GetStaticPaths } from "astro";
import "~/index.sass";
import "~/App.sass";
import "~/components/Blog/blog.sass";
import SectionHeader from "~/components/SectionHeader/SectionHeader";
import Layout from "~/components/Layout/Layout.astro";
import Pagination from "~/components/Pagination/Pagination.astro";
import sanitizeHtml from "sanitize-html";
import DefaultPage from "../../Layout/DefaultPage.astro";
export const getStaticPaths = (async ({ paginate }) => {
  const res = await fetch(import.meta.env.PUBLIC_API_URL + "/posts/");
  const dirtyData = (await res.json()).data as BlogPost[];
  // Truncate content
  const data = dirtyData.map((post) => {
    post.content = sanitizeHtml(post.content, {
      nestingLimit: 1,
      allowedTags: [],
      allowedAttributes: {},
    }).substring(0, 400);
    return post;
  });
  return paginate(data, { pageSize: 4 });
}) satisfies GetStaticPaths;
const { page } = Astro.props;
---

<style lang="sass">
  .rss-feed
    img
      width: 20px
</style>

<DefaultPage type="list">
  <Layout>
    <section id="blog">
      <SectionHeader title="Blog posts" tagline="Making things" as="h1" />
      <a
        href="/rss/feed.xml"
        title="Check out my RSS feed here !"
        class="rss-feed"
        ><img src="/rss_logo.webp" alt="The RSS logo" />{" "}Get the RSS feed
        here</a
      >
      <Pagination page={page} />
      <ul class="posts-list">
        {
          page.data.map((post: BlogPost) => (
            <li>
              <article>
                <img src={post.feature_image.original} alt={post.title} />
                <div>
                  <h4>{post.title}</h4>
                  <p class="excerpt">{post.content} ...</p>
                  <a href={"/post/" + post.slug}>
                    <button>Read more</button>
                  </a>
                </div>
              </article>
            </li>
          ))
        }
      </ul>
    </section>
    <Pagination page={page} />
  </Layout>
</DefaultPage>
